<%@ page language="C#" masterpagefile="site.master" %>
<%@ Import Namespace="System.DirectoryServices" %>
<%@ Import Namespace="System.DirectoryServices.Protocols" %>
<%@ Import Namespace="System.Diagnostics" %>
<%@ Import Namespace="CryptoHelper" %>

<script runat="server">

    protected void btnResetPassword_Click(object sender, EventArgs e)
    {
        // Set Default Panel visible propertes
        PnlResetPassword.Visible = true;
        pnlError.Visible = false;
        PnlConfirmReset.Visible = false;
        pnlSuccess.Visible = false;
        
                
        // make sure user typed in something here, if not, display an error.
        if (txtStudentID.Text.Length == 0)
        {
            pnlError.Visible = true;
            return;
        }
        
        
        // check to make sure this user is in the Student OU
        string strDistinguishedName = GetObjectProperty(txtStudentID.Text.ToString(), "distinguishedName");

        if (strDistinguishedName.ToLower().Contains("student"))
        {
            PnlResetPassword.Visible = false;
            PnlConfirmReset.Visible = true;
            hfStudentID.Value = txtStudentID.Text;
            lblStudentName.Text = GetObjectProperty(txtStudentID.Text.ToString(), "displayName");
        }
        else
        {
            lblErrorMsg.Text = "Error: Please make sure that you type in a valid Student ID.<br>You can ONLY reset STUDENT passwords with this tool!";
            pnlError.Visible = true;
            return;
        }
    }
 
    public static string GetObjectProperty(string pstrObject, string pstrProperty)
    {
        DirectorySearcher objSearch = new DirectorySearcher();
        SearchResult objResult = null;
        
        try
        {
            objSearch.Filter = String.Format("(SAMAccountName={0})",
            pstrObject);
            objSearch.PropertiesToLoad.Add(pstrProperty);
            objResult = objSearch.FindOne();
            return objResult.Properties[pstrProperty][0].ToString();
        }
        catch (System.Runtime.InteropServices.COMException)
        {
            return String.Empty;
        }
        catch (System.NullReferenceException)
        {
            return String.Empty;
        }
        catch (System.ArgumentOutOfRangeException)
        {
            return String.Empty;
        }
        catch (Exception)
        {
            throw;
        }
        finally
        {
            if (objResult != null)
            {
                objResult = null;
            }
            if (objSearch != null)
            {
                objSearch.Dispose();
                objSearch = null;
            }
        }
    }

    protected void btnNoReset_Click(object sender, EventArgs e)
    {
        PnlResetPassword.Visible = true;
        pnlError.Visible = false;
        PnlConfirmReset.Visible = false;

        txtStudentID.Focus();
    }

    protected void btnYesReset_Click(object sender, EventArgs e)
    {
        // set up Email logging
        string FROM = User.Identity.Name.ToString().ToLower().Replace(ConfigurationManager.AppSettings["SchoolDomain"] + "\\", "") + ConfigurationManager.AppSettings["EmailAddressEnd"];
        string SUBJECT;
        string MESSAGE = "";
		
		// set up Email to student
		
		string FROMSTU = "admin@yourdomain.com";
		string TOSTU = hfStudentID.Value + ConfigurationManager.AppSettings["EmailAddressEnd"];
		string SUBJECTSTU = "Password Change Information";
		string MESSAGESTU = "Your password has been changed.  Reminder: you have 2 weeks to change your password or your account will automatically be locked.  Follow this link for information on how to change your password: URLtoYourDoc";
		
		// bring over password from config file
		
		string NEWPASSWORD = ConfigurationManager.AppSettings["ResetPassword"];
        
        // Connect to Active Directory and get the DirectoryEntry object.
        DirectoryEntry oDE;
        oDE = new DirectoryEntry("LDAP://" + GetObjectProperty(txtStudentID.Text.ToString(), "distinguishedName"));

        try
        {            
            // Reset the password.
            oDE.Username = ConfigurationManager.AppSettings["AdminUserName"];
            oDE.Password = CryptoHelper.Decrypt(ConfigurationManager.AppSettings["AdminPassword"], ConfigurationManager.AppSettings["Passphrase"]);
            oDE.AuthenticationType = AuthenticationTypes.Secure;

            const int UF_ACCOUNTDISABLE = 0x0002;
            if (Convert.ToBoolean((int)oDE.Properties["userAccountControl"][0] & UF_ACCOUNTDISABLE))
            {
                lblErrorMsg.Text = lblStudentName.Text + "'s account is currently disabled. " + ConfigurationManager.AppSettings["DisabledErrorMessage"];
                pnlError.Visible = true;

                PnlResetPassword.Visible = true;
                PnlConfirmReset.Visible = false;
                txtStudentID.Focus();

                // for email logging
                SUBJECT = "DISABLED - " + lblStudentName.Text + " (" + hfStudentID.Value + ")";
            }
            else
            {

                oDE.Invoke("SetPassword", new object[] { ConfigurationManager.AppSettings["ResetPassword"] });

                //oDE.Properties["pwdLastSet"].Value = -1;
                oDE.CommitChanges();

                // if we make it this far, we have success!!!!
                lblStudentName1.Text = lblStudentName.Text;
                PnlConfirmReset.Visible = false;
                pnlSuccess.Visible = true;
                PnlResetPassword.Visible = true;
                txtStudentID.Text = "";
                txtStudentID.Focus();
                
                // for email logging
                SUBJECT = "RESET - " + lblStudentName.Text + " (" + hfStudentID.Value + ")";
                
            }
        }
        catch (Exception excep)
        {
            Response.Write("Error changing password.  Please contact the Help Desk with this error below<br><br>ERROR: " + excep.Message);
            SUBJECT = "ERROR - " + lblStudentName.Text + " (" + hfStudentID.Value + ")";
            MESSAGE = excep.Message;
        }
		
		// send email to logging email address
        System.Net.Mail.SmtpClient ObjEmail = new System.Net.Mail.SmtpClient();
        ObjEmail.Host = ConfigurationManager.AppSettings["SMTPServer"];
        ObjEmail.Send(/* From:   */ FROM,
                      /* To:     */ ConfigurationManager.AppSettings["LoggingEmailAddress"],
                      /* Subject */ SUBJECT,
                      /* Message */ MESSAGE);
					  
		// send email to student
        ObjEmail.Host = ConfigurationManager.AppSettings["SMTPServer"];
		ObjEmail.Send(/* From:   */ FROMSTU,
                      /* To:     */ TOSTU,
                      /* Subject */ SUBJECTSTU,
                      /* Message */ MESSAGESTU);
					  
        }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
            txtStudentID.Focus();
			
		//Response.Write(CryptoHelper.Encrypt("", ConfigurationManager.AppSettings["Passphrase"]));
    }

</script>

<asp:content id="w00t" contentplaceholderid="PageContent" runat="server">
    <center>
    <table width="80%">
    <tr>
    <td align="left">
    
    <asp:Panel ID="pnlSuccess" runat="server" Visible="false" BackColor="lightgreen" BorderColor="black" BorderWidth="2" Width="100%">
        <table width="100%" cellpadding="10">
            <tr align="center">
                <td>
                    <b>Password was reset successfully.</b><br /><br /><br />Please tell <asp:Label ID="lblStudentName1" runat="server"></asp:Label> that their new password is <b>staticpass</b>.  They will receive an email with instructions on how to change their password.<br /><br /><br />
                </td>
            </tr>
        </table>
    </asp:Panel>    
    <br />

    <center>
    <b>Please type in the Student ID of the student you would like to reset the password for:<br /></b>
    <br />

    <asp:Panel ID="pnlError" runat="server" Visible="false" BackColor="red" BorderColor="black" BorderWidth="2" Width="100%">
        <table width="100%" cellpadding="10">
            <tr align="center">
                <td>
                    <b><asp:Label ID="lblErrorMsg" runat="server" Font-Bold="true"></asp:Label></b>
                </td>
            </tr>
        </table>
    </asp:Panel>   
    <br /> 
    
    <asp:Panel ID="PnlResetPassword" runat="server" DefaultButton="btnResetPassword">
        <b>Student ID:
        <asp:TextBox ID="txtStudentID" runat="server"></asp:TextBox>
    &nbsp;<asp:Button ID="btnResetPassword" runat="server" 
            onclick="btnResetPassword_Click" Text="Reset Password" />
            <asp:RequiredFieldValidator ID="rfvStudentID" ControlToValidate="txtStudentID" ForeColor="red" Text="* Student ID is required" Display="Dynamic" runat="server"></asp:RequiredFieldValidator>
        </b>
    </asp:Panel> 
       
    <asp:Panel ID="PnlConfirmReset" runat="server" Visible="false" BackColor= "OrangeRed" BorderColor="black" BorderWidth="2" Width="100%">
        <table width="100%" cellpadding="10">
            <tr align="center">
                <td>
                    Are you sure you want to reset <b><asp:Label ID="lblStudentName" runat="server"></asp:Label>'s</b> password?<br />
                    <br />
                    <asp:HiddenField ID="hfStudentID" runat="server" /><br />
                    <asp:HiddenField ID="txtPassword" runat="server" value="" /><br />
                    <br />&nbsp;
                    <asp:Button ID="btnYesReset" runat="server" Text=" Yes " OnClick="btnYesReset_Click" CausesValidation="true" />&nbsp;&nbsp;&nbsp;&nbsp;<asp:Button 
                        ID="btnNoReset" runat="server" Text="No / Cancel" onclick="btnNoReset_Click" CausesValidation="false" />
                </td>
            </tr>
        </table>
    </asp:Panel>    
    </center>    
    <br />
    <br />
    </td>
    </tr>
    </table>
    </center>
&nbsp;</asp:content>