﻿#############################################################
# Title       : Send welcome email to new students          #
# Author      : Eric Krebill                                #
# Date / Ver  : 10/29/2018 / 1.2                            #
#############################################################

######################### Universal Variables #########################
[xml]$univar = Get-Content C:\PowerShell\UniVar\UniVar.xml
$detailFile = $univar.var.stulog + "DETAIL_Email_New_Students.txt"
$studentou = $univar.var.stuou
$emaildomain = $univar.var.domain
$SMTPServer = $univar.var.smtpserver
$SMTPPort = $univar.var.smtpport
$From = $univar.var.fromaddy
######### Consult README before modifying Universal Variables #########

# Email body information
$Subject = "New User Information"
$Body = "Welcome to Tri County Area Schools.  Your account has been automatically created.  Reminder: you have 2 weeks to change your password or your account will automatically be locked.  Follow this link for information on how to change your password: https://goo.gl/iSiASB"

# Change the properties variables to match the fields you need to use in the script.  
# Do not remove whenCreated variable as that's needed later on.
$students = Get-ADUser -filter "mail -like '*$emaildomain'" -Searchbase $studentou -ResultSetSize $null -Properties whenCreated,mail,division `

FOREACH ($user in $students)
{
  $email = $user.mail

  #Checks to see if the user was created within the last day
  IF ($user.whenCreated -ge ((Get-Date).AddDays(-1)).Date)
  {
    IF ($user.division -eq "Lookup_Not_Available") 
    {
      Send-MailMessage -From $From -to $user.mail -Subject $Subject -Body $Body -SmtpServer $SMTPServer -port $SMTPPort

      Add-Content -Path $detailFile -Value "$(Get-Date) - Email sent to $email" -PassThru
    }
  }
}
