﻿#############################################################
# Title       : Export AD student data                      #
# Author      : Eric Krebill                                #
# Date / Ver  : 10/29/2018 / 1.2                            #
#############################################################

######################### Universal Variables #########################
[xml]$univar = Get-Content $env:HOMEDRIVE\PowerShell\UniVar\UniVar.xml
$logfile = $univar.var.stulog + 'LOG_MOVE_Inactive_Students.txt'
$studentou = $univar.var.stuou
######### Consult README before modifying Universal Variables #########

Import-Module ActiveDirectory

# This is the OU that we're going to move the exited students TO
$TargetOU = 'OU=Exited,OU=TC Student Users,DC=TCS,DC=local'

# Set the current date for logging
$currentdate = Get-Date

$DisabledAccounts = Get-ADUser -filter "enabled -eq $false" -Searchbase $studentou -ResultSetSize $null -Properties DistinguishedName,sAMAccountName `

FOREACH ($account in $DisabledAccounts)
{
  Move-ADObject -Identity $account.DistinguishedName -TargetPath $TargetOU
  
  Add-Content -Path $logfile -Value "$currentdate - User moved - $sAMAccountName"
}
