﻿#############################################################
# Title       : GAM - Add students to Class Groups          #
# Author      : Eric Krebill                                #
# Date / Ver  : 7/12/2018 / 2.1                             #
#############################################################

######################### Universal Variables #########################
[xml]$univar = Get-Content $env:HOMEDRIVE\PowerShell\UniVar\UniVar.xml
$logFile = $univar.var.stulog + 'LOG_GAM_ClassGroups.txt'
$detailFile = $univar.var.stulog + 'DETAIL_GAM_ClassGroups.txt'
$gamPath = $univar.var.gam
$studentou = $univar.var.stuou
$emaildomain = $univar.var.domain
######### Consult README before modifying Universal Variables #########

# Change the properties variables to match the fields you need to use in the script.  
# Do not remove whenCreated variable as that's needed later on.
$students = Get-ADUser -filter "mail -like '*$emaildomain'" -Searchbase $studentou -ResultSetSize $null -Properties whenCreated,mail,description `

# Logging and housekeeping
Add-Content -Path $logFile -Value "Process started $(Get-Date)" -PassThru

FOREACH ($user in $students)
{
  $group = $user.description + $emaildomain
  $email = $user.mail
    
  #Checks to see if the user was created within the last day
  IF ($user.whenCreated -ge ((Get-Date).AddDays(-1)).Date)
  {
    & $gamPath update group $group add users $email
   
    Add-Content -Path $detailFile -Value "$(Get-Date) - $email added to $group" -PassThru
  }
}

# More logging
Add-Content -Path $logFile -Value "Process completed $(Get-Date)" -PassThru