﻿#############################################################
# Title       : GAM - Move students to Class OUs            #
# Author      : Eric Krebill                                #
# Date / Ver  : 10/29/2018 / 2.1                            #
#############################################################

######################### Universal Variables #########################
[xml]$univar = Get-Content C:\PowerShell\UniVar\UniVar.xml
$logFile = $univar.var.stulog + "LOG_GAM_MoveStudents_Weekly.txt"
$detailFile = $univar.var.stulog + "DETAIL_GAM_MoveStudents_Weekly.txt"
$gamPath = $univar.var.gam
$studentou = $univar.var.stuou
$emaildomain = $univar.var.domain
######### Consult README before modifying Universal Variables #########

# Change the properties variables to match the fields you need to use in the script.  
# Do not remove whenCreated variable as that's needed later on.
$students = Get-ADUser -filter "mail -like '*$emaildomain'" -Searchbase $studentou -ResultSetSize $null -Properties whenCreated,mail,description `

# Logging and housekeeping
Add-Content -Path $logFile -Value "Process started $(Get-Date)" -PassThru

FOREACH ($user in $students)
{
  $email = $user.mail
  $googleou = "/Students/" + $user.description

  & $gamPath update org $googleou add users $email

  Add-Content -Path $detailFile -Value "$(Get-Date) - $email moved to $googleou" -PassThru
}

# More logging
Add-Content -Path $logFile -Value "Process completed $(Get-Date)" -PassThru