﻿#############################################################
# Title       : GAM - Set student passwords                 #
# Author      : Eric Krebill                                #
# Date / Ver  : 10/29/2018 / 2.1                            #
#############################################################

######################### Universal Variables #########################
[xml]$univar = Get-Content C:\PowerShell\UniVar\UniVar.xml
$logFile = $univar.var.stulog + "LOG_GAM_SetPasswords.txt"
$detailFile = $univar.var.stulog + "DETAIL_GAM_SetPasswords.txt"
$gamPath = $univar.var.gam
$studentou = $univar.var.stuou
$emaildomain = $univar.var.domain
$defaultpw = $univar.var.defaultpw
######### Consult README before modifying Universal Variables #########

# Change the properties variables to match the fields you need to use in the script.  
# Do not remove whenCreated variable as that's needed later on.
$students = Get-ADUser -filter "mail -like '*$emaildomain'" -Searchbase $studentou -ResultSetSize $null -Properties whenCreated,mail,division `

# Logging and housekeeping
Add-Content -Path $logFile -Value "Process started $(Get-Date)" -PassThru

FOREACH ($user in $students)
{
  $email = $user.mail
  $pass = $user.division

  #Checks to see if the user was created within the last day
  IF ($user.whenCreated -ge ((Get-Date).AddDays(-1)).Date)
  {
    IF ($pass -eq "Lookup_Not_Available") {
      & $gamPath update user $email password $defaultpw

      Add-Content -Path $detailFile -Value "$(Get-Date) - Default password set for $email" -PassThru
    }
    ELSE
    {
      & $gamPath update user $email password $pass

      Add-Content -Path $detailFile -Value "$(Get-Date) - Static password set for $email" -PassThru
    } 
  }
}

# More logging
Add-Content -Path $logFile -Value "Process completed $(Get-Date)" -PassThru
